<?php
echo "\n\n";
echo "This code demonstrates accessing\$this inside of a closure in PHP 5.4\n";
echo "It was written by Cal Evans <cal@calevans.com> as part of his\n";
echo "presentation at CodeWorks 2011. \n";
echo "\n";
echo "It is so simple and useless that it would be laughable to attempt\n";
echo "to assign it a license. Therefore all code herein is released into the \n";
echo "public domain by the author.\n\n";

/*
 * Dummy Class just to show the principal
 */
class DummyClass {
    protected $_name = 'Unknown ';
    protected $_counter = 0;
    
    public function whatsMyName()
    {
        return function() {
            ++$this->_counter;
            return 'My name is '.$this->_name;};
    }
    
    public function getCounter()
    {
        return $this->_counter;
    }
}

echo "Creating the object\n";
$o = new DummyClass('Cal');
echo "Now grabbing the closure\n";
$c = $o->whatsMyName(); // this returns a closure, NOT a string.
echo "\$c is now a closure object. Let's execute it 3 times\n";
echo $c()."\n"; // execute the closure
echo $c()."\n"; // execute the closure
echo $c()."\n"; // execute the closure
echo "Now let's look at the counter. Counter = " . $o->getCounter();
echo "\n";
echo "Because it mantains a pointer to \$this, we can even null the original object\n";
echo "and it will still work.\n";
$o = null;

echo $c()."\n"; // execute the closure
echo $c()."\n"; // execute the closure
echo $c()."\n"; // execute the closure
echo "Since we can't look at the counter because \$o is null, let's print_r()";
echo "the closure, we'll see the properties of the original object.\n";
print_r($c);
echo "\nThere, we are done. \n";
die();
