<?php
echo "\n\n";
echo "This code demonstrates the new traits feature in PHP 5.4\n";
echo "It was written by Cal Evans <cal@calevans.com> as part of his\n";
echo "presentation at CodeWorks 2011. \n";
echo "\n";
echo "It is so simple and useless that it would be laughable to attempt\n";
echo "to assign it a license. Therefore all code herein is released into the \n";
echo "public domain by the author.\n\n";

/*
 * Define a simple, albeit stupid, trait.
 */
trait Counter
{
    public function increment()
    {
        ++$this->_counter;
        return;
    }
    public function decrement()
    {
        --$this->_counter;
        return;
    }
    public function getCounter()
    {
        echo "Counter Trait\n";
        return $this->_counter;
    }
    
} // trait Counter

/*
 * Define a second trait with an identical method so we can show conflict resolution.
 */
trait SecondCounter
{
    
    public function getCounter()
    {
        echo "Second Counter Trait\n";
        return $this->_counter;
    }
    
}
/*
 * Define a class that uses the trait
 */
class MyBaseClass
{
    public function getCounter()
    {
        echo "My Base Class\n";
        return $this->_counter;
        
    }
    
}

class MyClass extends MyBaseClass
{
    use Counter, SecondCounter
    {
      Counter::getCounter as counterGetCounter;
      SecondCounter::getCounter as secondCounterGetCounter;  
    }
    protected $_counter;
    
    public function getCounter()
    {
        echo "My Class \n";
        return $this->_counter;
        
    }
}

 
/*
 * Instantiate the class and use the methods in the trait.
 */
$o = new MyClass();
$o->increment();
$o->increment();
echo $o->getCounter()."\n";
$o->decrement();
$o->decrement();
$o->decrement();
$o->decrement();
$o->decrement();
echo $o->getCounter()."\n";
/*
 * Now show the first Trait's counter method
 */
echo $o->counterGetCounter()."\n";
/*
 * Now show the Second Trait's counter method
 */
echo $o->secondCounterGetCounter()."\n";

/*
 * Show the object
 */ 
print_r($o);

echo "\n\nThere, we are done. \n";
die();
